local _G = getfenv(0)

function Skinner:BlizzardFrames()
	-- self:Debug("BlizzardFrames")

	-- only need to do this once
	if self.initialized.BlizzardFrames then return end
	self.initialized.BlizzardFrames = true

	self:characterFrames()
	self:PetStableFrame()
	self:SpellBookFrame()
	self:DressUpFrame()
	self:FriendsFrame()
	self:TradeFrame()
--	self:QuestLog() -- checked with EQL3 below
	self:reSizeQW()

	self:Tooltips()
	self:MirrorTimers()
	self:QuestTimers()
	self:CastingBar()
	self:StaticPopups()
	self:ChatFrames()
	self:ChatTabs()
	self:ChatEditBox()
	self:LootFrame()
	self:GroupLoot()
	self:ContainerFrames()
	self:StackSplit()
	self:ItemText()
	self:WorldMap()
	self:ColorPicker()
	self:HelpFrame()
	self:KnowledgeBaseFrame()
	self:MainMenuBar()
	self:CoinPickup()
	self:LFGFrame()
	self:BattleScore()

	self:menuFrames()
	self:BankFrame()
	self:MailFrame()
	self:makeModelFramesRotatable()
	
	self:merchantFrames()
	self:GossipFrame()
	self:TaxiFrame()
	self:QuestFrame()
	self:Battlefields()
	self:ArenaFrame()
	self:GuildRegistrar()
	self:Petition()
	self:Tabard()

	self:ViewPort()
	self:TopFrame()
	self:MiddleFrames()
	self:BottomFrame()
    
	--	Skin the ScriptErrors Frame 
    self:applySkin(ScriptErrors)
	-- skin the Tutorial Frame
	self:applySkin(TutorialFrame)
	
	-- hook these to Skin the DropDown frames
	for i = 1, 3 do
		local ddFrame = "DropDownList"..i
		if _G[ddFrame] then
			self:HookScript(_G[ddFrame], "OnShow", function()
				self.hooks[_G[ddFrame]].OnShow()
				self:removeRegions(_G[ddFrame])
				_G[ddFrame.."Backdrop"]:Hide()
				_G[ddFrame.."MenuBackdrop"]:Hide()
				self:applySkin(_G[ddFrame])
				end)
		end
	end

end

function Skinner:AddonFrames()
	-- self:Debug("AddonFrames")
	
	-- only need to do this once
	if self.initialized.AddonFrames then return end
	self.initialized.AddonFrames = true

	-- used for Addons that aren't LoadOnDemand
	if self:checkAddOn("BugSack") then self:BugSack() end
	if self:checkAddOn("OneBag") then self:OneBag() end
	if self:checkAddOn("GMail") then self:GMail() end
	if self:checkAddOn("CT_MailMod") then self:CT_MailMod() end
	if self:checkAddOn("EnhancedStackSplit") then self:EnhancedStackSplit() end
	if self:checkAddOn("CT_RaidAssist") then self:CT_RaidAssist() end
    if self:checkAddOn("SuperInspect_UI") then self:SuperInspect_UI() end
	if self:checkAddOn("MCP") then self:MCP() end
	if self:checkAddOn("MyBags") then self:MyBags() end
	if self:checkAddOn("AxuItemMenus") then self:AxuItemMenus() end
	if self:checkAddOn("EnhancedTradeSkills") then self:EnhancedTradeSkills() self:EnhancedTradeCrafts() end
	if self:checkAddOn("AutoProfit") then self:AutoProfit() end
	if self:checkAddOn("FuBar_GarbageFu") then self:FuBar_GarbageFu() end
	if self:checkAddOn("FuBar_DurabilityFu") then self:FuBar_DurabilityFu() end
	if self:checkAddOn("MetaMap") then self:MetaMap() end
	if self:checkAddOn("LootLink") then self:LootLink() end
	if self:checkAddOn("Possessions") then self:Possessions() end
	if self:checkAddOn("ReagentHeaven") then self:ReagentHeaven() end
	if self:checkAddOn("LinkHeaven") then self:LinkHeaven() end
	if self:checkAddOn("EQL3") then self:EQL3() elseif self.db.profile.QuestLog.skin then self:QuestLog() end
	if self:checkAddOn("BattleChat") then self:BattleChat() end
	if self:checkAddOn("KombatStats") then self:KombatStats()	end
	if self:checkAddOn("FruityLoots") then self:FruityLoots() end
	if self:checkAddOn("ItemSync") then self:ItemSync() end
	if self:checkAddOn("oCD") then self:oCD() end
	if self:checkAddOn("GotWood") then self:GotWood() end
	if self:checkAddOn("aftt_extreme") then self:aftt_extreme() end
	if self:checkAddOn("EasyUnlock") then self:EasyUnlock() end
    if self:checkAddOn("SuperMacro") then self:SuperMacro() end
    if self:checkAddOn("MailTo") then self:MailTo() end
    if self:checkAddOn("HoloFriends") then self:HoloFriends() end
    if self:checkAddOn("PVPCooldown") then self:PVPCooldown() end
    if self:checkAddOn("PVPCooldownReborn") then self:PVPCooldown() end
    if self:checkAddOn("BuyPoisons") then self:BuyPoisons() end		
    if self:checkAddOn("KLHThreatMeter") then self:KLHThreatMeter() end
    if self:checkAddOn("IgorsMassAuction") then self:IgorsMassAuction() self:AuctionFrame() end
	if self:checkAddOn("myBindings") then self:myBindings() end
	if self:checkAddOn("GCInfo") then self:GCInfo() end
	if self:checkAddOn("Outfitter") then self:Outfitter() end
	if self:checkAddOn("UberQuest") then self:UberQuest() end
	if self:checkAddOn("CharactersViewer") then self:CharactersViewer() end
	if self:checkAddOn("AdvancedTradeSkillWindow") then self:AdvancedTradeSkillWindow() end
	if self:checkAddOn("EavesDrop") then self:EavesDrop() end
	if self:checkAddOn("Clique") then self:Clique() end
	if self:checkAddOn("DepositBox") then self:DepositBox() end
	if self:checkAddOn("AuctionFilterPlus") then self:AuctionFilterPlus() end
	if self:checkAddOn("MonkeyQuest") then self:MonkeyQuest()	end
	if self:checkAddOn("MonkeyQuestLog") then self:MonkeyQuestLog()	end
	if self:checkAddOn("Cartographer") then self:Cartographer()	end
	if self:checkAddOn("MobileFrames") then self:MobileFrames() end
	if self:checkAddOn("ArgentDawnGrinder") then self:ArgentDawnGrinder() end
	if self:checkAddOn("Atlas") then self:Atlas() end
	if self:checkAddOn("AtlasLoot") then self:AtlasLoot() end
	if self:checkAddOn("AutoDecline") then self:AutoDecline() end
	if self:checkAddOn("SW_Stats") then self:SW_Stats() end
	if self:checkAddOn("StanceSets") then self:StanceSets() end
	if self:checkAddOn("Badapples") then self:Badapples() end
	if self:checkAddOn("FramesResized") then self:FramesResized() end
	if self:checkAddOn("FactionGrinder") then self:FactionGrinder() end
	if self:checkAddOn("vBagnon") then self:vBagnon() end
	if self:checkAddOn("EngBags") then self:EngBags() end
	if self:checkAddOn("Hadar_FocusFrame") then self:Hadar_FocusFrame() end
	if self:checkAddOn("Converse") then self:Converse() end
	if self:checkAddOn("ArkInventory") then self:ArkInventory() end
	if self:checkAddOn("GFW_FeedOMatic") then self:GFW_FeedOMatic() end
	if self:checkAddOn("Chatr") then self:Chatr() end
	

	-- handle Addons with odd names here
    if IsAddOnLoaded("!ImprovedErrorFrame") and type(self["ImprovedErrorFrame"]) == "function" then self:ImprovedErrorFrame() end
	if IsAddOnLoaded("Auto-Bag") and type(self["AutoBag"]) == "function" then self:AutoBag() end

	-- skin TabletLib frames
	if AceLibrary:HasInstance("Tablet-2.0") and self.Tablet then self:Tablet() end
	-- skin DewdropLib frames
	if AceLibrary:HasInstance("Dewdrop-2.0") and self.Dewdrop then self:Dewdrop() end

end

function Skinner:LoDFrames(arg1)
--	 self:Debug("LoDFrames: [%s]", arg1)

	if arg1 == prev_arg1 then return end
	prev_arg1 = arg1
	
	-- used for LoadOnDemand Addons
	if arg1 == "Blizzard_RaidUI" then self:RaidUI() end
	if arg1 == "Blizzard_MacroUI" then self:MacroFrame() end
	if arg1 == "Blizzard_BindingUI" then self:KeyBindingFrame() end
	if arg1 == "Blizzard_InspectUI" then self:InspectFrame() end
	if arg1 == "Blizzard_AuctionUI" then self:AuctionFrame() end
	if arg1 == "Blizzard_AuctionUI" and self:checkAddOn("Auctioneer") then self:Auctioneer() end
	if arg1 == "Blizzard_TrainerUI" then self:ClassTrainer() end
	if arg1 == "Blizzard_TradeSkillUI" then self:TradeSkill() end
	if arg1 == "Blizzard_CraftUI" then self:CraftFrame() end
	if arg1 == "Blizzard_TalentUI" then self:TalentFrame() end
	if arg1 == "Blizzard_GMSurveyUI" then self:GMSurveyUI() end
	if arg1 == "Blizzard_ItemSocketingUI" then self:ItemSocketingUI() end

	
	-- ignore the addon if required to by the user
	if not self:checkAddOn(arg1) then return end
	
	if arg1 == "OneBank" then self:OneBank() end
 	if arg1 == "Bagnon" then self:Bagnon() end
	if arg1 == "Banknon" then self:Banknon() end
	if arg1 == "SuperInspect_UI" then self:SuperInspect_UI() end
	if arg1 == "GFW_AutoCraft" then self:GFW_AutoCraft() end
	if arg1 == "SpecialTalentUI" then self:SpecialTalentUI() end
	if arg1 == "FilterTradeSkill" then self:FilterTradeSkill() end
	if arg1 == "cgCrafty" then self:cgCrafty() end
	if arg1 == "EnhTooltip" then self:EnhTooltip() end
	if arg1 == "LootLink_Options" then self:LootLink_Options() end
	if arg1 == "LootLink_QuickChatlink" then self:LootLink_QuickChatlink() end
	if arg1 == "FramesResized_TalentUI" then self:FramesResized_TalentUI() end

end

function Skinner:ADDON_LOADED(arg1)
--	 self:Debug("ADDON_LOADED: [%s]", arg1)
 
	self:ScheduleEvent(self.LoDFrames, self.db.profile.Delay.LoDs, self, arg1)
  
end

function Skinner:ViewPort()
	if not self.db.profile.ViewPort.shown or self.initialized.ViewPort then return end
	self.initialized.ViewPort = true

	WorldFrame:SetPoint("TOPLEFT", 0, -(self.db.profile.ViewPort.top * self.db.profile.ViewPort.scaling))
	WorldFrame:SetPoint("BOTTOMRIGHT", -0, (self.db.profile.ViewPort.bottom * self.db.profile.ViewPort.scaling))
	
	if self.db.profile.ViewPort.overlay then
		ViewportOverlay = WorldFrame:CreateTexture(nil, "BACKGROUND")
		ViewportOverlay:SetTexture(self.db.profile.ViewPort.r or 0, self.db.profile.ViewPort.g or 0, self.db.profile.ViewPort.b or 0, ba or self.db.profile.ViewPort.a or 1)
		ViewportOverlay:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -1, 1)
		ViewportOverlay:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 1, -1)
	end
	
end

function Skinner:ViewPort_top()
	if not self.db.profile.ViewPort.shown then return end

	WorldFrame:SetPoint("TOPLEFT", 0, -(self.db.profile.ViewPort.top * self.db.profile.ViewPort.scaling))
	
end

function Skinner:ViewPort_bottom()
	if not self.db.profile.ViewPort.shown then return end

	WorldFrame:SetPoint("BOTTOMRIGHT", -0, (self.db.profile.ViewPort.bottom * self.db.profile.ViewPort.scaling))
	
end

function Skinner:ViewPort_reset()

	self.initialized.ViewPort = nil
    WorldFrame:SetPoint("TOPLEFT", 0, -0)
	WorldFrame:SetPoint("BOTTOMRIGHT", -0, 0)
	
end

function Skinner:TopFrame()
	if not self.db.profile.TopFrame.shown or self.initialized.TopFrame then return end
	self.initialized.TopFrame = true

	local frame = CreateFrame("Frame", "SkinnerTF", UIParent)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(false)
	frame:SetMovable(false)
	frame:SetWidth(self.db.profile.TopFrame.width or 1920)
	frame:SetHeight(self.db.profile.TopFrame.height or 100)
	frame:ClearAllPoints()
	if self.db.profile.TopFrame.xyOff  or self.db.profile.TopFrame.borderOff then 
		frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -6, 6)
	else
		frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", -3, 3)
	end
	self.topframe = frame
	local fb = self.db.profile.TopFrame.borderOff and 0 or 1
	self:applySkin(frame, nil, fb, self.db.profile.TopFrame.alpha, self.db.profile.TopFrame.fheight)

	if self.db.profile.TopFrame.invert then
		if self.db.profile.FadeHeight.enable then
			fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
		end
		frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, 4)
		if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", 4, fh)
		else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 4, -4) end
   		frame.tfade:SetGradientAlpha("VERTICAL", MaxR, MaxG, MaxB, MaxA, MinR, MinG, MinB, MinA)
	end
	
end

function Skinner:MiddleFrames()

    for i = 1, 5 do
		if self.db.profile["MiddleFrame"..i].shown then self:createMiddleFrame(i) end
	end
	   
end

function Skinner:BottomFrame()
	if not self.db.profile.BottomFrame.shown or self.initialized.BottomFrame then return end
	self.initialized.BottomFrame = true

	local frame = CreateFrame("Frame", "SkinnerBF", UIParent)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(false)
	frame:SetMovable(false)
	frame:SetWidth(self.db.profile.BottomFrame.width or 1920)
	frame:SetHeight(self.db.profile.BottomFrame.height or 200)
	frame:ClearAllPoints()
	if self.db.profile.BottomFrame.xyOff  or self.db.profile.BottomFrame.borderOff then 
		frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", -6, -6)
	else
		frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", -3, -3)
	end
	self.bottomframe = frame
	local fb = self.db.profile.BottomFrame.borderOff and 0 or 1
	self:applySkin(frame, nil, fb, self.db.profile.BottomFrame.alpha, self.db.profile.BottomFrame.fheight)

	if self.db.profile.BottomFrame.invert then
		if self.db.profile.FadeHeight.enable then
			fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
		end
		frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", -4, 4)
		if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", 4, fh)
		else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 4, -4) end
   		frame.tfade:SetGradientAlpha("VERTICAL", MaxR, MaxG, MaxB, MaxA, MinR, MinG, MinB, MinA)
	end

end
                 
function Skinner:createMiddleFrame(frameId)

	local dbkey = "MiddleFrame"..frameId
	local mfkey = self.db.profile[dbkey]
                
	self.initialized[dbkey] = true
	
	local frame = CreateFrame("Frame", "SkinnerMF"..frameId, UIParent)
	frame:SetID(frameId)
	frame:SetFrameStrata("BACKGROUND")
	frame:SetFrameLevel(0)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetResizable(true)
	frame:SetWidth(mfkey.width)
	frame:SetHeight(mfkey.height)
	frame:SetPoint("CENTER", UIParent, "CENTER", mfkey.xOfs, mfkey.yOfs)
	frame:RegisterForDrag("LeftButtonUp")
	if not OnMouseDown then
		OnMouseDown = function()
			if arg1 == "LeftButton" and IsAltKeyDown() then
				this.isMoving = true
				this:StartMoving()
				this:Raise()
			end
			if arg1 == "LeftButton" and IsControlKeyDown() then
				this.isMoving = true
				this:StartSizing("BOTTOMRIGHT")
				this:Raise()
			end
		end
	end
	frame:SetScript("OnMouseDown", OnMouseDown)

	if not OnMouseUp then
		OnMouseUp = function()
			local this = this
			if arg1 == "LeftButton" then
				if this.isMoving then
					this:StopMovingOrSizing()
					this.isMoving = nil
 					this:SetFrameStrata("BACKGROUND")
					this:SetFrameLevel(0)       
					local x, y = this:GetCenter()
					local px, py = this:GetParent():GetCenter()
					local dbkey = "MiddleFrame"..this:GetID()
 					self.db.profile[dbkey].xOfs = x - px
					self.db.profile[dbkey].yOfs = y - py
    				self.db.profile[dbkey].width = math.floor(this:GetWidth())
					self.db.profile[dbkey].height = math.floor(this:GetHeight())  														   						  
				end
			end
		end
	end
	frame:SetScript("OnMouseUp", OnMouseUp)
	if not OnHide then
		OnHide = function()
	 		if this.isMoving then
	  			this:StopMovingOrSizing()
	  			this.isMoving = nil
	 		end
		end
	end
	frame:SetScript("OnHide", OnHide)

	local fb = self.db.profile.MiddleFrame.borderOff and 0 or 1
	self:applySkin(frame, nil, fb, nil, self.db.profile.MiddleFrame.fheight)
	frame:SetBackdropColor(self.db.profile.MiddleFrame.r, self.db.profile.MiddleFrame.g, self.db.profile.MiddleFrame.b, self.db.profile.MiddleFrame.a)
	
	self["middleframe"..frameId] = frame
	
	frame:Show()
	
end
